#version 120

#define ExposaUnique

#define VClouds

const int noiseTextureResolution = 256;

varying vec3 lightVector;
varying vec3 colSky;
varying vec3 colFog;
varying vec3 sunlight;

uniform mat4 gbufferProjection;
uniform mat4 gbufferModelView;
uniform mat4 gbufferProjectionInverse;
uniform mat4 gbufferModelViewInverse;
uniform mat4 gbufferPreviousModelView;
uniform mat4 gbufferPreviousProjection;
uniform mat4 shadowModelView;
uniform mat4 shadowModelViewInverse;
uniform mat4 shadowProjection;
uniform mat4 shadowProjectionInverse;

uniform sampler2D colortex0;
uniform sampler2D colortex7;
uniform sampler2D depthtex0;
uniform sampler2D depthtex1;
uniform sampler2D noisetex;
uniform sampler2D colortex5;

varying vec4 texcoord;
uniform vec3 cameraPosition;
uniform vec3 previousCameraPosition;

uniform float frameTimeCounter;
uniform int frameCounter;
uniform float viewHeight;
uniform float viewWidth;
uniform float far;
uniform float near;


uniform vec3 sunPosition;

uniform float rainStrength;
uniform float sunAngle;

float bayer2(vec2 a){
    a = floor(a);
    return fract( dot(a, vec2(.5, a.y * .75)) );
}

#define bayer4(a)   (bayer2( .5*(a))*.25+bayer2(a))
#define bayer8(a)   (bayer4( .5*(a))*.25+bayer2(a))
#define bayer16(a)  (bayer8( .5*(a))*.25+bayer2(a))

#define rcp(x) (1.0 / x)

void main() {

/*DRAWBUFFERS:0*/
    const float cLOD    = sqrt(4.0);
    #ifdef VClouds
    vec2 cloudcoord = texcoord.st*rcp(cLOD);
    vec4 clouds = texture2D(colortex7, cloudcoord);
    #endif
    vec4 col = texture2D(colortex0, texcoord.st);
    float depth = texture2D(depthtex0, texcoord.st).x;
    #ifdef VClouds
    if (depth>=1.0) col.rgb = mix(col.rgb, clouds.rgb, clouds.a);
    if (depth>=1.0) col.a = mix(col.a, 1.0, 1.0);
    #endif

    gl_FragData[0] = col;
   
}